05Robot 3.0

- Main Page
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Properties | List of all members
Processor_PlaneCalibration Class Reference
Computer Vision Module

Perspective correction image processor. More...

`#include <Processor_PlaneCalibration.h>`

Inheritance diagram for Processor_PlaneCalibration:

## Public Member Functions
void | Setcheckerboard_columns (int _arg_checkerboard_columns)
| Sets checkerboard_columns property value. More...
int | checkerboard_columns () const
| Gets checkerboard_columns property value. More...
void | Setcheckerboard_rows (int _arg_checkerboard_rows)
| Sets checkerboard_rows property value. More...
int | checkerboard_rows () const
| Gets checkerboard_rows property value. More...
void | Setcheckerboard_raster (double _arg_checkerboard_raster)
| Sets checkerboard_raster property value. More...
double | checkerboard_raster () const
| Gets checkerboard_raster property value. More...
void | Setworkspace_x_offset (double _arg_workspace_x_offset)
| Sets workspace_x_offset property value. More...
double | workspace_x_offset () const
| Gets workspace_x_offset property value. More...
void | Setworkspace_y_offset (double _arg_workspace_y_offset)
| Sets workspace_y_offset property value. More...
double | workspace_y_offset () const
| Gets workspace_y_offset property value. More...
void | Setworkspace_x_size (double _arg_workspace_x_size)
| Sets workspace_x_size property value. More...
double | workspace_x_size () const
| Gets workspace_x_size property value. More...
void | Setworkspace_y_size (double _arg_workspace_y_size)
| Sets workspace_y_size property value. More...
double | workspace_y_size () const
| Gets workspace_y_size property value. More...
void | Setpicture_width (int _arg_picture_width)
| Sets picture_width property value. More...
int | picture_width () const
| Gets picture_width property value. More...
void | Setpicture_height (int _arg_picture_height)
| Sets picture_height property value. More...
int | picture_height () const
| Gets picture_height property value. More...
| Processor_PlaneCalibration ()
| Initializes default parameters. More...
int | start ()
| Starts image processing. More...
int | process (int t1, int t2)
| Processes frames in input buffer. More...
int | processSpecial (string s)
| Processes special command. More...
int | stop ()
| Stops image processing. More...
virtual void | writeXml (QXmlStreamWriter &stream)
| Writes properties and current calibration matrix to XML stream. More...
virtual void | readXml (QXmlStreamReader &stream)
| Reads properties and calibration matrix from XML stream. More...
Public Member Functions inherited from Processor
| Processor ()
| Starts internal clock. More...
Public Member Functions inherited from cXmlIO
| cXmlIO (int _xmlID=0, QObject *parent=nullptr)
virtual QString | sXmlKey ()
| Generates key of XML entry (as name of the serialised class is) More...
virtual void | findInXML (QString &fileName, bool compareXmlID=true)
| serches th file for XML key corr to class name and fill class properties according to entries found More...
virtual void | writeCsvData (QXmlStreamWriter &stream, QString key, const QVector< QVector< double > > &s)
virtual void | writeCsvVector (QXmlStreamWriter &stream, QString key, const QVector< double > &s)
virtual void | readCsvData (QXmlStreamReader &stream, QVector< QVector< double > > &s)
virtual void | readCsvVector (QXmlStreamReader &stream, QVector< double > &s)
virtual void | write64BaseData (QXmlStreamWriter &stream, QString key, const QVector< QVector< double > > &s)
virtual void | read64BaseData (QXmlStreamReader &stream, QVector< QVector< double > > &s)
template<typename T >
void | writeData (QXmlStreamWriter &stream, QString key, const T &data)
template<typename T >
void | readData (QXmlStreamReader &stream, T &data)
int | getXmlID () const
void | setXmlID (int value)

## Properties
int | checkerboard_columns
| Number of chessboard internal columns (crossings) More...
int | checkerboard_rows
| Number of chessboard internal rows (crossings) More...
double | checkerboard_raster
| Chessboard field size, in meters. More...
double | workspace_x_offset
| Offset between lower-left chessboard corner crossing and workspace origin in x axis, in meters. More...
double | workspace_y_offset
| Offset between lower-left chessboard corner crossing and workspace origin in y axis, in meters. More...
double | workspace_x_size
| Workspace size along x axis, in meters. More...
double | workspace_y_size
| Workspace size along y axis, in meters. More...
int | picture_width
| Output picture width, in pixels. More...
int | picture_height
| Output picture height, in pixels. More...
Properties inherited from cXmlIO
int | xmlID
| Defines uniqe identifier for object in XML file. More...

## Additional Inherited Members
Public Types inherited from Processor
Signals inherited from Processor
void | writeInfo (QString info)
| Data logger. More...
Static Public Member Functions inherited from cXmlIO
static void | metaCopy (QObject *dest, QObject *src)
Public Attributes inherited from Processor
InputType | inputType
| Processor input data type. More...
vector< cv::Mat * > | inputMat
| Vector of input images. More...
vector< vector< cv::Point2f > * > | inputPoint2
| Vector of input series of 2D points. More...
vector< vector< cv::Point3d > * > | inputPoint3
| Vector of input series of 3D points. More...
vector< QString * > | cameraName
| Vector of pointers to connected cameras names. More...
vector< cv::Mat * > | outputMat
| Vector of output images. More...
vector< vector< cv::Point2f > * > | outputPoint2
| Vector of output series of 2D points. More...
vector< vector< cv::Point3d > * > | outputPoint3
| Vector of input series of 3D points. More...
QTime | m_time
| Internal clock. More...
Protected Member Functions inherited from cXmlIO
void | metaDataXmlReader (QXmlStreamReader &stream, QObject &obj, bool isUser=true)
void | metaDataXmlWriter (QXmlStreamWriter &stream, const QObject &obj, bool isUser=true)

## Detailed Description

Perspective correction image processor.

Calculates perspective correction based on a chessboard placed in the workspace, performs perspective correction accordingly.

## Constructor & Destructor Documentation

Processor_PlaneCalibration | ( |  | ) |
| inline

Initializes default parameters.

## Member Function Documentation

int checkerboard_columns | ( |  | ) | const

Gets checkerboard_columns property value.

double checkerboard_raster | ( |  | ) | const

Gets checkerboard_raster property value.

int checkerboard_rows | ( |  | ) | const

Gets checkerboard_rows property value.

int picture_height | ( |  | ) | const

Gets picture_height property value.

int picture_width | ( |  | ) | const

Gets picture_width property value.

int process | ( | int | t1,
|  | int | t2
| ) |  |
| virtual

Processes frames in input buffer.

Parameters

  t1 | Cameras trigger time
  t2 | Cameras acquisition finish time

Returns
  0 on success

Reimplemented from Processor.

int processSpecial | ( | string | s | ) |
| virtual

Processes special command.

Valid commands are:
calibrate: calculates transformation between camera and workspace based on current frame, switches to perspective correction mode
reset: switches to chessboard search mode

Parameters

  s | Command string

Returns
  0 on success

Reimplemented from Processor.

virtual void readXml | ( | QXmlStreamReader & | stream | ) |
| virtual

Reads properties and calibration matrix from XML stream.

Parameters

  stream | XML stream to read from

Reimplemented from cXmlIO.

void Setcheckerboard_columns | ( | int | _arg_checkerboard_columns | ) |

Sets checkerboard_columns property value.

void Setcheckerboard_raster | ( | double | _arg_checkerboard_raster | ) |

Sets checkerboard_raster property value.

void Setcheckerboard_rows | ( | int | _arg_checkerboard_rows | ) |

Sets checkerboard_rows property value.

void Setpicture_height | ( | int | _arg_picture_height | ) |

Sets picture_height property value.

void Setpicture_width | ( | int | _arg_picture_width | ) |

Sets picture_width property value.

void Setworkspace_x_offset | ( | double | _arg_workspace_x_offset | ) |

Sets workspace_x_offset property value.

void Setworkspace_x_size | ( | double | _arg_workspace_x_size | ) |

Sets workspace_x_size property value.

void Setworkspace_y_offset | ( | double | _arg_workspace_y_offset | ) |

Sets workspace_y_offset property value.

void Setworkspace_y_size | ( | double | _arg_workspace_y_size | ) |

Sets workspace_y_size property value.

int start | ( |  | ) |
| virtual

Starts image processing.

Returns
  0 on success

Reimplemented from Processor.

int stop | ( |  | ) |
| virtual

Stops image processing.

Returns
  0 on success

Reimplemented from Processor.

double workspace_x_offset | ( |  | ) | const

Gets workspace_x_offset property value.

double workspace_x_size | ( |  | ) | const

Gets workspace_x_size property value.

double workspace_y_offset | ( |  | ) | const

Gets workspace_y_offset property value.

double workspace_y_size | ( |  | ) | const

Gets workspace_y_size property value.

virtual void writeXml | ( | QXmlStreamWriter & | stream | ) |
| virtual

Writes properties and current calibration matrix to XML stream.

Parameters

  stream | XML stream to write to

Reimplemented from cXmlIO.

## Property Documentation

int checkerboard_columns
| read write

Number of chessboard internal columns (crossings)

double checkerboard_raster
| read write

Chessboard field size, in meters.

int checkerboard_rows
| read write

Number of chessboard internal rows (crossings)

int picture_height
| read write

Output picture height, in pixels.

int picture_width
| read write

Output picture width, in pixels.

double workspace_x_offset
| read write

Offset between lower-left chessboard corner crossing and workspace origin in x axis, in meters.

double workspace_x_size
| read write

Workspace size along x axis, in meters.

double workspace_y_offset
| read write

Offset between lower-left chessboard corner crossing and workspace origin in y axis, in meters.

double workspace_y_size
| read write

Workspace size along y axis, in meters.

The documentation for this class was generated from the following file:

- processors/Processor_PlaneCalibration.h